/*
 * cdrom-dummy.c
 *
 *   Copyright (C) Ueno Katsuhiro 2000
 *
 * $Id: cdrom-dummy.c,v 1.2 2000/10/20 22:55:12 katsu Exp $
 */

#include "ruby.h"
#include "rbcd.h"

#define dummy_error()   rb_raise(rb_eIOError, "dummy driver :-p")


void rbcd_open(union rbcd_device *cdrom, const char *device)
{
}

void rbcd_close(union rbcd_device cdrom)
{
}

void rbcd_inject(union rbcd_device cdrom)
{
}

void rbcd_eject(union rbcd_device cdrom)
{
}

void rbcd_lock_door(union rbcd_device cdrom, int locked)
{
}

void rbcd_get_track_range(union rbcd_device cdrom, int *start, int *end)
{
	/* pseudo disc has one data track. */
	*start = 1;
	*end = 1;
}

void rbcd_get_track(union rbcd_device cdrom,
		    int track_no, struct rbcd_track *track)
{
	if (track_no < 0) {
		track->track_type = RBCD_LEADOUT;
		track->start_addr.lba = 1;
	} else {
		if (track_no != 1)
			dummy_error();
		track->track_type = RBCD_DATA_TRACK;
		track->start_addr.lba = 0;
	}
}

int rbcd_get_last_session_addr(union rbcd_device cdrom,
			       struct rbcd_time *addr)
{
	return 0;
}

void rbcd_play_audio(union rbcd_device cdrom,
		     struct rbcd_time *start, struct rbcd_time *end)
{
}

void rbcd_pause_audio(union rbcd_device cdrom)
{
}

void rbcd_resume_audio(union rbcd_device cdrom)
{
}

void rbcd_stop_audio(union rbcd_device cdrom)
{
}

void rbcd_read_audio(union rbcd_device cdrom,
		     struct rbcd_time *addr, int frames, char *dst)
{
	dummy_error();
}

void rbcd_read_mode1(union rbcd_device cdrom,
		     struct rbcd_time *addr, int frames, char *dst)
{
	dummy_error();
}

void rbcd_read_mode2(union rbcd_device cdrom,
		     struct rbcd_time *addr, int frames, char *dst)
{
	dummy_error();
}

void rbcd_read_raw(union rbcd_device cdrom,
		   struct rbcd_time *addr, int frames, char *dst)
{
	dummy_error();
}

void rbcd_get_status(union rbcd_device cdrom, struct rbcd_status *status)
{
	status->status = RBCD_NO_STATUS;
	status->track_no = 1;
	status->addr.lba = 0;
	status->track_time.min   = 0;
	status->track_time.sec   = 0;
	status->track_time.frame = 0;
}

void rbcd_get_volume(union rbcd_device cdrom, int *left, int *right)
{
	*left = *right = 255;
}

void rbcd_set_volume(union rbcd_device cdrom, int left, int right)
{
}

int rbcd_num_slots(union rbcd_device cdrom)
{
	return 1;
}

int rbcd_change_slot(union rbcd_device cdrom, int slot)
{
	if (slot <= 0)
		return 0;
	dummy_error();
}

int rbcd_is_ready(union rbcd_device cdrom, int slot)
{
	if (slot > 0)
		dummy_error();
	return 1;
}
