require 'mkmf'
require 'rbconfig'
include Config


def have_libcdaudio(major, minor, micro)
  print 'checking for libcdaudio >= 0.99.0... '
  STDOUT.flush
  ret = false
  r,w = IO.pipe
  fork {
    begin
      r.close
      STDIN.close
      STDERR.close
      STDOUT.reopen w
      exec 'libcdaudio-config', '--version'
    rescue
    end
  }
  w.close
  version = r.read
  if version then
    v = version.split('.', 3).collect { |i| i.to_i }
    if v[0] >= major and v[1] >= minor and v[2] >= micro then
      ret = true
    end
  end
  if ret then
    print "yes\n"
    $CFLAGS += ' ' + `libcdaudio-config --cflags`.strip
    $libs += ' ' + `libcdaudio-config --libs`.strip
  else
    print "no\n"
  end
  ret
end



driver = with_config('driver')
driver = nil if driver.nil? or not File.exist? 'cdrom-' + driver + '.c'

unless driver then
  driver = 'dummy'
  if have_header('linux/cdrom.h') then
    driver = 'linux'
  #elsif have_header('sys/cdio.h') then
  #  driver = 'freebsd'
  elsif have_libcdaudio(0, 99, 0) then
    driver = 'cdaudio'
  end
end


dev = with_config('default-device')

unless dev then
  case CONFIG['host_os']
  when 'linux' then
    dev = '/dev/cdrom'
  else
    dev = '/dev/cdrom'
  end
end


$CFLAGS += " -DDEFAULT_DEVICE=\\\"#{dev}\\\""
print 'checking for which CD-ROM driver is used... ', driver, "\n"
print 'checking for the default device... ', dev, "\n"

$objs = [ 'cdrom.o', 'cdrom-' + driver + '.o' ]
create_makefile('cdrom')
